package de.ibh.RandomArt;

import java.util.List;

public class RAOSin extends AbstractRAOperatorA1 {
	protected double phase;
	protected double freq;
	
	public RAOSin(RAPRNG prng) {
		super(prng);
	}

	@Override
	public void init(List<AbstractRAOperator> ops) {
		super.init(ops);

		phase = prng.uniform(0, Math.PI);
		freq = prng.uniform(1, 6);
	}
	
	@Override
	public double[] eval(final double x, final double y) {
		double rgb[] = ops.get(0).eval(x, y);

		RAUtilities.checkRGB(rgb);
		
		return new double[] {Math.sin(phase + freq * rgb[0]), Math.sin(phase + freq * rgb[1]), Math.sin(phase + freq * rgb[2])};
	}
}
