/**
 * 
 */
package de.ibh.RandomArt;

import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;

import de.ibh.RandomArt.RAImage;

/**
 * @author liske
 *
 */

public class RATest2 {
	private Shell sShell;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new RATest2();
		System.exit(0);
	}
	
	public RATest2() {
		Display display = Display.getDefault();

		createSShell();
		sShell.open();

		while (!sShell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}
	
	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		sShell = new Shell();

        sShell.setText("Random Art Testbed");
		sShell.setLayout(new GridLayout());
		
		final ScrolledComposite sc = new ScrolledComposite(sShell, SWT.V_SCROLL);		
		sc.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		
		Composite c = new Composite(sc, SWT.NONE | SWT.BORDER);
		c.setLayout(new GridLayout(15, true));

		final Group g = new Group(c, SWT.SHADOW_ETCHED_IN);
		g.setLayout(new GridLayout(2, false));
		g.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true));

		Label l = new Label(g, SWT.NONE);
		l.setText("Seed:");
		
		final Image img = RAImage.create("", g.getDisplay());
		Canvas canvas = new Canvas(g, SWT.NONE);
		canvas.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent e) {
				e.gc.drawImage(img, 0, 0);
			}
		});
//		canvas.setLayoutData(gd);

		c.pack(true);
		c.update();
		

		sc.setContent(c);
	    sc.setExpandHorizontal(true);
	    sc.setExpandVertical(true);
	    sc.setMinSize(c.computeSize(SWT.DEFAULT, SWT.DEFAULT));
	}
}
