/**
 * 
 */
package de.ibh.StrongRoom.Client.SWT;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import de.ibh.StrongRoom.l10n.StrongRoomL10N;

/**
 * @author ellguth
 *
 */
public class CloseTabDialog extends Dialog {
    private final StrongRoomL10N l10n = StrongRoomL10N.getInstance();
    private String message;
    private Button btnCancel;
    private Button btnCloseNoSave;
    private Button btnSave;
    
    private int r;
    public static final int CTD_SAVE = 1;
    public static final int CTD_CLOSENOSAVE = 2;
    public static final int CTD_CANCEL = 4;
    
    public CloseTabDialog(Shell shell, String name) {
        super(shell, SWT.DIALOG_TRIM);

        setText(l10n._("Close Tab"));
        setMessage(l10n._("Save changes to `") + name + l10n._("' before closing?"));
    }
    
    
    public void setMessage(String message) {
        this.message = message;
    }
    
    
    /**
     * Opens the dialog and returns int
     * 
     * @return String
     */
    public int open() {
      // Create the dialog window
      Shell shell = new Shell(getParent(), getStyle());
      shell.setText(getText());
      createContents(shell);
      shell.pack();
      shell.open();
      Display display = getParent().getDisplay();
      btnCancel.setFocus();

      while (!shell.isDisposed()) {
        if (!display.readAndDispatch()) {
          display.sleep();
        }
      }
      // Return the entered value
      return r;
    }
    

    private void createContents(final Shell shell) {
        shell.setLayout(new GridLayout(3, false));

        Composite c = new Composite(shell, SWT.NONE);
        c.setLayout(new GridLayout(2, false));
        GridData data = new GridData();
        data.horizontalSpan = 3;
        c.setLayoutData(data);
        
        // Show icon
        Label label = new Label(c, SWT.NONE);
        label.setImage(shell.getDisplay().getSystemImage(SWT.ICON_QUESTION));
        data = new GridData();
        label.setLayoutData(data);        

        // Show the message
        label = new Label(c, SWT.NONE);
        label.setText(message);
        data = new GridData();
        label.setLayoutData(data);        
        
        btnSave = new Button(shell, SWT.PUSH);
        btnSave.setText(l10n._("Save"));
        data = new GridData(SWT.CENTER, SWT.CENTER, true, false);
        btnSave.setLayoutData(data);
        btnSave.addSelectionListener(new SelectionAdapter() {
          public void widgetSelected(SelectionEvent event) {
            shell.close();
            r = CTD_SAVE;
          }
        });
        
        btnCloseNoSave = new Button(shell, SWT.PUSH);
        btnCloseNoSave.setText(l10n._("Close without saving"));
        data = new GridData(SWT.CENTER, SWT.CENTER, true, false);
        btnCloseNoSave.setLayoutData(data);
        btnCloseNoSave.addSelectionListener(new SelectionAdapter() {
          public void widgetSelected(SelectionEvent event) {
            shell.close();
            r = CTD_CLOSENOSAVE;
          }
        });        

        btnCancel = new Button(shell, SWT.PUSH);
        btnCancel.setText(l10n._("Cancel"));
        data = new GridData(SWT.CENTER, SWT.CENTER, true, false);
        btnCancel.setLayoutData(data);
        btnCancel.addSelectionListener(new SelectionAdapter() {
          public void widgetSelected(SelectionEvent event) {
            shell.close();
            r = CTD_CANCEL;
          }
        });
    }
}
