/**
 * 
 */
package de.ibh.StrongRoom.Client.SWT;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;

import de.ibh.StrongRoom.Log.ErrorMessage;


/**
 * @author ellguth
 *
 */
public class ErrorMsgDialog implements ErrorMessage {
    static private ErrorMsgDialog dlg = null;
    private Shell shell                 = null;
    
    
    public ErrorMsgDialog(Shell shell) {
        this.shell = shell;
    }
    
    
    static public ErrorMsgDialog getInstance(Shell shell) {
        if (dlg != null) {
        	dlg.updateShell(shell);
            return dlg;
        }
        
        dlg = new ErrorMsgDialog(shell);
        
        return dlg;
    }    

    public void updateShell(Shell shell) {
    	this.shell = shell;
    }
    
    /* (non-Javadoc)
     * @see de.ibh.StrongRoom.DB.ErrorMessage#printErrorMessage(java.lang.String)
     */
    public void printErrorMessage(String msg, EMessageTypes style) {
        if(shell == null) return;

        int mbstyle = 0;
        if(style == EMessageTypes.TYPE_ERROR) mbstyle = SWT.OK | SWT.ICON_ERROR;
        else if(style == EMessageTypes.TYPE_WARN) mbstyle = SWT.OK | SWT.ICON_WARNING;
        else if(style == EMessageTypes.TYPE_INFO) mbstyle = SWT.OK | SWT.ICON_INFORMATION;
        
        MessageBox mb = new MessageBox(shell, mbstyle);

        mb.setMessage(msg);
        mb.open();
    }

}
