package de.ibh.StrongRoom.Client.SWT;

import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeItem;

import de.ibh.StrongRoom.Client.Crypto;
import de.ibh.StrongRoom.Client.Config.BaseConf;
import de.ibh.StrongRoom.Client.Lucene.SearchResult;
import de.ibh.StrongRoom.Client.Lucene.SRSearch.EDocFields;
import de.ibh.StrongRoom.DB.DBConn;
import de.ibh.StrongRoom.DB.Role;
import de.ibh.StrongRoom.Exception.SRGenericException;
import de.ibh.StrongRoom.l10n.StrongRoomL10N;

public class SearchDetailResults {
	Shell shell;
    private StrongRoomL10N l10n = StrongRoomL10N.getInstance();	

	public SearchDetailResults(final Shell s, final DBConn dbconn, final Crypto crypto, final BaseConf baseconf, final Map<Role, List<SearchResult>> tds) throws SRGenericException {
		shell = new Shell(s);

		shell.setText(l10n._("Search results"));
		shell.setLayout(new GridLayout(2, false));


	    /* Results tree */
        final Tree tree = new Tree(s, SWT.FILL | SWT.SINGLE | SWT.BORDER | SWT.V_SCROLL);
        tree.setHeaderVisible(false);
        tree.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));
        
        for(Role role : tds.keySet()) {
        	for(SearchResult sr : tds.get(role)) {
        		final TreeItem ti = new TreeItem(tree, SWT.DEFAULT);
        		ti.setText(sr.getScore() + " " + sr.getDoc().getField(EDocFields.SUBJECT.name()).toString());
        	}
        }

        /* Close button */
	    Button closeButton = new Button(shell, SWT.PUSH);
	    closeButton.setImage(shell.getDisplay().getSystemImage(SWT.CANCEL));
	    closeButton.setText(l10n._("&Close"));
	    closeButton.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false));
	    closeButton.addSelectionListener(new SelectionAdapter() {
	      public void widgetSelected(SelectionEvent event) {
	        shell.close();
	      }
	    });

		shell.pack();
		shell.open();
	    Display display = shell.getDisplay();
	    while (!shell.isDisposed()) {
	    	if (!display.readAndDispatch())
	    		display.sleep();
	    }
	    shell.dispose();
	}
}
