package de.ibh.StrongRoom.DB;

import java.util.HashMap;
import java.util.Map;

import de.ibh.StrongRoom.Crypto.CryptoBackend.ECryptoPGP_KeyType;

public class PublicKey implements ISignedRow {
    private String fpr;
    private String pubKey;
    private String signSKey;
    
    PublicKey(final String fpr, final String pubKey, final String signSKey) {
        this.fpr = fpr;
        this.pubKey = pubKey;
        this.signSKey = signSKey;
    }
    
    
    public String getFPR() {
        return this.fpr;
    }
    
    
    public String getPubKey() {
        return this.pubKey;
    }


	@Override
	public Map<ECryptoPGP_KeyType, String> getSignKeyMap() {
		Map<ECryptoPGP_KeyType, String> m = new HashMap<ECryptoPGP_KeyType, String>();

		m.put(ECryptoPGP_KeyType.SIGNING_KEY, signSKey);

		return m;
	}


	@Override
	public String[] getSignStrings() {
		return new String[] {fpr, pubKey};
	}


	@Override
	public void setSigningData(ECryptoPGP_KeyType kt, String sig) {
		if(kt == ECryptoPGP_KeyType.SIGNING_KEY)
			signSKey = sig;
		else
			throw new IllegalArgumentException();
	
	}
}
