//---------------------------------------------------------------------------
// Freely available from Media Art Online (http://www.media-art-online.org/).
// Copyright (C) 2005 Media Art Online (cafe@media-art-online.org)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// PROJECT: PGP/GnuPG Applications
// MODULE:  GnuPG support
// FILE:    GnuPGSignature.java
//
// DESCRIPTION:
//
// REVISION HISTORY:
//  Name      Date        Description
//  ----      ----------  -----------
//  ks91      2005/03/24  initial version
//
// $Id: //depot/scm/main/java/org/media_art_online/gnupg/GnuPGSignature.java#2 $
// $DateTime: 2005/03/25 11:15:39 $
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
// Package
//---------------------------------------------------------------------------
package org.media_art_online.gnupg;

//---------------------------------------------------------------------------
// Import
//---------------------------------------------------------------------------
import java.io.*;
import org.media_art_online.encoding.Base64;

public class GnuPGSignature {

	public static long getTimeFromBase64(String s) {

		long lTime = 0;
		OutputStreamWriter writer;
		ByteArrayOutputStream output;

		try {
			writer = new OutputStreamWriter(new Base64.OutputStream(
			 output = new ByteArrayOutputStream(), Base64.DECODE));

			writer.write(s);
			writer.close();
			byte[] buf = output.toByteArray();

			for (int i = 0; i < buf.length; i++) {

				if (buf[i] == OCTET_VERSION_3) {

					lTime = Long.parseLong(toHex(buf[i + OFFSET_OCTET_1])
					 + toHex(buf[i + OFFSET_OCTET_2])
					 + toHex(buf[i + OFFSET_OCTET_3])
					 + toHex(buf[i + OFFSET_OCTET_4]), 16) * I_MILLISECONDS;
					break;
				}
			}

		} catch (IOException unused) {
		}

		return (lTime);
	}

	private static String toHex(byte b) {

		int x = (b & 0xff);
		String s = Integer.toString(x, 16);

		return ((s.length() < 2 ? "0" : "") + s);
	}

	/*
	private static final int BITS_24 = 24;
	private static final int BITS_16 = 16;
	private static final int BITS_8  =  8;
	 */
	
	private static final int I_MILLISECONDS = 1000;

	private static final int OCTET_VERSION_3 = 3;

	private static final int OFFSET_OCTET_1 = 3;
	private static final int OFFSET_OCTET_2 = 4;
	private static final int OFFSET_OCTET_3 = 5;
	private static final int OFFSET_OCTET_4 = 6;
};

// GnuPGSignature.java
